//	Synthesizer.h - Base class for all synthesizers.
//  ----------------------------------------------------------------------------
//	This file is part of 'GameTemplate', template code for a game.
//	Copyright (C) 2010  Niall Moody
//	
//	This program is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program.  If not, see <http://www.gnu.org/licenses/>.
//	----------------------------------------------------------------------------

#ifndef SYNTHESIZER_H_
#define SYNTHESIZER_H_

///	Base class for all synthesizers.
class Synthesizer
{
  public:
	///	Constructor.
	Synthesizer(){};
	///	Destructor.
	virtual ~Synthesizer() {};

	///	Returns the audio for this synthesizer.
	virtual void getAudio(float *buffer, int numSamples) = 0;

	///	Sets whether or not this synthesizer is active.
	virtual void setActive(bool val, int startSample, bool hi) = 0;
	///	Returns whether or not this synthesizer is active.
	virtual bool getActive() const = 0;
};

#endif
